Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/JobView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/JobView.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/JobView.cs	(revision 8887)
@@ -31,5 +31,5 @@
   public partial class JobView : ItemView {
     private ItemListView<Task> tasksView;
-    private bool SuppressEvents = false;
+    protected bool SuppressEvents = false;
 
     public new Job Content {
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/TaskView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/TaskView.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding.Views/3.3/TaskView.cs	(revision 8887)
@@ -30,5 +30,5 @@
   [Content(typeof(Task))]
   public partial class TaskView : ItemView {
-    private bool SuppressEvents = false;
+    protected bool SuppressEvents = false;
 
     public new Task Content {
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/HeuristicLab.Encodings.ScheduleEncoding-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/HeuristicLab.Encodings.ScheduleEncoding-3.3.csproj	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/HeuristicLab.Encodings.ScheduleEncoding-3.3.csproj	(revision 8887)
@@ -110,5 +110,4 @@
   <ItemGroup>
     <Compile Include="Interfaces\IDirectScheduleOperator.cs" />
-    <Compile Include="Interfaces\IScheduleEvaluationAlgorithm.cs" />
     <Compile Include="Interfaces\IJSMOperator.cs" />
     <Compile Include="Interfaces\IPRVOperator.cs" />
@@ -116,7 +115,5 @@
     <Compile Include="Interfaces\IScheduleCreator.cs" />
     <Compile Include="Interfaces\IScheduleCrossover.cs" />
-    <Compile Include="Interfaces\IScheduleDecoder.cs" />
     <Compile Include="Interfaces\IScheduleEncoding.cs" />
-    <Compile Include="Interfaces\IScheduleEvaluator.cs" />
     <Compile Include="Interfaces\IScheduleManipulator.cs" />
     <Compile Include="Interfaces\IScheduleOperator.cs" />
@@ -151,5 +148,4 @@
     <Compile Include="ScheduleEncoding\Job.cs" />
     <Compile Include="ScheduleEncoding\Manipulators\DirectScheduleManipulator.cs" />
-    <Compile Include="ScheduleEncoding\Manipulators\ConcreteScheduleManipulator.cs" />
     <Compile Include="ScheduleEncoding\DirectScheduleRandomCreator.cs" />
     <Compile Include="ScheduleEncoding\Resource.cs" />
@@ -158,5 +154,4 @@
     <Compile Include="ScheduleCreator.cs" />
     <Compile Include="ScheduleCrossover.cs" />
-    <Compile Include="ScheduleDecoder.cs" />
     <Compile Include="ScheduleEncoding\Task.cs" />
     <Compile Include="ScheduleManipulator.cs" />
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IJSMOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IJSMOperator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IJSMOperator.cs	(revision 8887)
@@ -1,3 +1,24 @@
-﻿using HeuristicLab.Core;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
 
 namespace HeuristicLab.Encodings.ScheduleEncoding {
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IPRVOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IPRVOperator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IPRVOperator.cs	(revision 8887)
@@ -1,3 +1,24 @@
-﻿using HeuristicLab.Core;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
 
 namespace HeuristicLab.Encodings.ScheduleEncoding {
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IPWROperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IPWROperator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IPWROperator.cs	(revision 8887)
@@ -1,3 +1,24 @@
-﻿using HeuristicLab.Core;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
 
 namespace HeuristicLab.Encodings.ScheduleEncoding {
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleCreator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleCreator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleCreator.cs	(revision 8887)
@@ -1,6 +1,29 @@
-﻿using HeuristicLab.Optimization;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
 
 namespace HeuristicLab.Encodings.ScheduleEncoding {
   public interface IScheduleCreator : ISolutionCreator, IScheduleOperator {
+    ILookupParameter<IScheduleEncoding> ScheduleEncodingParameter { get; }
   }
 }
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleCrossover.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleCrossover.cs	(revision 8887)
@@ -1,6 +1,30 @@
-﻿using HeuristicLab.Optimization;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
 
 namespace HeuristicLab.Encodings.ScheduleEncoding {
   public interface IScheduleCrossover : ICrossover, IScheduleOperator {
+    ILookupParameter<IScheduleEncoding> ChildParameter { get; }
+    IScopeTreeLookupParameter<IScheduleEncoding> ParentsParameter { get; }
   }
 }
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleManipulator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleManipulator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleManipulator.cs	(revision 8887)
@@ -20,8 +20,10 @@
 #endregion
 
+using HeuristicLab.Core;
 using HeuristicLab.Optimization;
 
 namespace HeuristicLab.Encodings.ScheduleEncoding {
   public interface IScheduleManipulator : IManipulator, IScheduleOperator {
+    ILookupParameter<IScheduleEncoding> ScheduleEncodingParameter { get; }
   }
 }
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleOperator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleOperator.cs	(revision 8887)
@@ -1,3 +1,24 @@
-﻿using HeuristicLab.Core;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
 
 namespace HeuristicLab.Encodings.ScheduleEncoding {
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMCrossover.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMCrossover.cs	(revision 8887)
@@ -27,5 +27,5 @@
   [Item("JSMCrossover", "An operator which crosses two JSM representations.")]
   [StorableClass]
-  public abstract class JSMCrossover : ScheduleCrossover<JSMEncoding>, IJSMOperator {
+  public abstract class JSMCrossover : ScheduleCrossover, IJSMOperator {
 
     [StorableConstructor]
@@ -41,5 +41,5 @@
 
     public override IOperation Apply() {
-      ItemArray<JSMEncoding> parents = ParentsParameter.ActualValue;
+      var parents = ParentsParameter.ActualValue;
 
       ChildParameter.ActualValue =
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMJOXCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMJOXCrossover.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMJOXCrossover.cs	(revision 8887)
@@ -30,17 +30,16 @@
   [StorableClass]
   public class JSMJOXCrossover : JSMCrossover {
+
     [StorableConstructor]
     protected JSMJOXCrossover(bool deserializing) : base(deserializing) { }
-    protected JSMJOXCrossover(JSMJOXCrossover original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected JSMJOXCrossover(JSMJOXCrossover original, Cloner cloner) : base(original, cloner) { }
+    public JSMJOXCrossover() : base() { }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new JSMJOXCrossover(this, cloner);
     }
-    public JSMJOXCrossover() : base() { }
-
 
     public static JSMEncoding Apply(IRandom random, JSMEncoding p1, JSMEncoding p2) {
-      JSMEncoding result = new JSMEncoding();
+      var result = new JSMEncoding();
 
       int nrOfResources = p1.JobSequenceMatrix.Count;
@@ -48,5 +47,5 @@
 
       //Determine randomly which jobindexes persist
-      BoolArray persist = new BoolArray(nrOfJobs);
+      var persist = new BoolArray(nrOfJobs);
       for (int i = 0; i < persist.Length; i++) {
         persist[i] = random.Next(2) == 1;
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMOXCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMOXCrossover.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMOXCrossover.cs	(revision 8887)
@@ -28,17 +28,16 @@
   [StorableClass]
   public class JSMOXCrossover : JSMCrossover {
+
     [StorableConstructor]
     protected JSMOXCrossover(bool deserializing) : base(deserializing) { }
-    protected JSMOXCrossover(JSMOXCrossover original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected JSMOXCrossover(JSMOXCrossover original, Cloner cloner) : base(original, cloner) { }
+    public JSMOXCrossover() : base() { }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new JSMOXCrossover(this, cloner);
     }
-    public JSMOXCrossover() : base() { }
-
 
     public static JSMEncoding Apply(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
-      JSMEncoding result = new JSMEncoding();
+      var result = new JSMEncoding();
 
       for (int i = 0; i < parent1.JobSequenceMatrix.Count; i++) {
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMSXXCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMSXXCrossover.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMSXXCrossover.cs	(revision 8887)
@@ -29,21 +29,20 @@
   [StorableClass]
   public class JSMSXXCrossover : JSMCrossover {
+
     [StorableConstructor]
     protected JSMSXXCrossover(bool deserializing) : base(deserializing) { }
-    protected JSMSXXCrossover(JSMSXXCrossover original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected JSMSXXCrossover(JSMSXXCrossover original, Cloner cloner) : base(original, cloner) { }
+    public JSMSXXCrossover() : base() { }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new JSMSXXCrossover(this, cloner);
     }
-    public JSMSXXCrossover() : base() { }
-
 
     public static JSMEncoding Apply(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
-      JSMEncoding result = new JSMEncoding();
+      var result = new JSMEncoding();
       int subSequenceLength = random.Next(parent1.JobSequenceMatrix[0].Length);
       for (int i = 0; i < parent1.JobSequenceMatrix.Count; i++) {
-        Permutation p1 = (Permutation)parent1.JobSequenceMatrix[i].Clone();
-        Permutation p2 = (Permutation)parent2.JobSequenceMatrix[i].Clone();
+        var p1 = (Permutation)parent1.JobSequenceMatrix[i].Clone();
+        var p2 = (Permutation)parent2.JobSequenceMatrix[i].Clone();
         FindAndExchangeSubsequences(p1, p2, subSequenceLength);
         result.JobSequenceMatrix.Add(p1);
@@ -51,4 +50,5 @@
       return result;
     }
+
     private static void FindAndExchangeSubsequences(Permutation p1, Permutation p2, int subSequenceLength) {
       for (int i = 0; i <= p1.Length - subSequenceLength; i++) {
@@ -63,6 +63,7 @@
       }
     }
+
     private static void ExchangeSubsequences(Permutation p1, int index1, Permutation p2, int index2, int subSequenceLength) {
-      Permutation aux = (Permutation)p1.Clone();
+      var aux = (Permutation)p1.Clone();
       for (int i = 0; i < subSequenceLength; i++) {
         p1[i + index1] = p2[i + index2];
@@ -70,4 +71,5 @@
       }
     }
+
     private static bool AreEqualSubsequences(int[] ss1, int[] ss2) {
       int counter = 0;
@@ -80,6 +82,7 @@
       return counter == ss1.Length;
     }
+
     private static int[] GetSubSequenceAtPosition(Permutation p1, int index, int subSequenceLength) {
-      int[] result = new int[subSequenceLength];
+      var result = new int[subSequenceLength];
       for (int i = 0; i < subSequenceLength; i++)
         result[i] = p1[i + index];
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JSMRandomCreator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JSMRandomCreator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JSMRandomCreator.cs	(revision 8887)
@@ -28,10 +28,9 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-
 namespace HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix {
   [Item("JobSequenceMatrixCreator", "Creator class used to create Job Sequence Matrix solutions for standard JobShop scheduling problems.")]
   [StorableClass]
-  public class JSMRandomCreator : ScheduleCreator<JSMEncoding>, IStochasticOperator {
-    #region Parameter Properties
+  public class JSMRandomCreator : ScheduleCreator, IStochasticOperator {
+
     public ILookupParameter<IRandom> RandomParameter {
       get { return (LookupParameter<IRandom>)Parameters["Random"]; }
@@ -43,15 +42,8 @@
       get { return (IValueLookupParameter<IntValue>)Parameters["Resources"]; }
     }
-    #endregion
-
 
     [StorableConstructor]
     protected JSMRandomCreator(bool deserializing) : base(deserializing) { }
-    protected JSMRandomCreator(JSMRandomCreator original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new JSMRandomCreator(this, cloner);
-    }
+    protected JSMRandomCreator(JSMRandomCreator original, Cloner cloner) : base(original, cloner) { }
     public JSMRandomCreator()
       : base() {
@@ -63,17 +55,17 @@
     }
 
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new JSMRandomCreator(this, cloner);
+    }
 
     public static JSMEncoding Apply(int jobs, int resources, IRandom random) {
-      JSMEncoding solution = new JSMEncoding();
-
+      var solution = new JSMEncoding();
       for (int i = 0; i < resources; i++) {
         solution.JobSequenceMatrix.Add(new Permutation(PermutationTypes.Absolute, jobs, random));
       }
-
       return solution;
     }
 
-
-    protected override JSMEncoding CreateSolution() {
+    protected override IScheduleEncoding CreateSolution() {
       return Apply(JobsParameter.ActualValue.Value, ResourcesParameter.ActualValue.Value, RandomParameter.ActualValue);
     }
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMManipulator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMManipulator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMManipulator.cs	(revision 8887)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -27,5 +28,5 @@
   [Item("JSMManipulator", "An operator which manipulates a JSM representation.")]
   [StorableClass]
-  public abstract class JSMManipulator : ScheduleManipulator<JSMEncoding>, IJSMOperator {
+  public abstract class JSMManipulator : ScheduleManipulator, IJSMOperator {
     [StorableConstructor]
     protected JSMManipulator(bool deserializing) : base(deserializing) { }
@@ -36,9 +37,9 @@
     }
 
-    protected abstract void Manipulate(IRandom random, JSMEncoding individual);
-
+    protected abstract void Manipulate(IRandom random, IScheduleEncoding individual);
 
     public override IOperation Apply() {
-      JSMEncoding solution = ScheduleEncodingParameter.ActualValue;
+      var solution = ScheduleEncodingParameter.ActualValue as JSMEncoding;
+      if (solution == null) throw new InvalidOperationException("ScheduleEncoding was not found or is not of type JSMEncoding.");
       Manipulate(RandomParameter.ActualValue, solution);
       return base.Apply();
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMShiftChangeManipulator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMShiftChangeManipulator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMShiftChangeManipulator.cs	(revision 8887)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -28,19 +29,16 @@
 
 namespace HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix {
-
   [Item("JSMShiftChangeManipulator", "Represents a manipulation operation where the operations of a randomly determined job are shifted in one direction for all resources.")]
   [StorableClass]
   public class JSMShiftChangeManipulator : JSMManipulator {
+
     [StorableConstructor]
     protected JSMShiftChangeManipulator(bool deserializing) : base(deserializing) { }
-    protected JSMShiftChangeManipulator(JSMShiftChangeManipulator original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected JSMShiftChangeManipulator(JSMShiftChangeManipulator original, Cloner cloner) : base(original, cloner) { }
+    public JSMShiftChangeManipulator() : base() { }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new JSMShiftChangeManipulator(this, cloner);
     }
-
-    public JSMShiftChangeManipulator() : base() { }
-
 
     public static void Apply(IRandom random, JSMEncoding individual) {
@@ -65,6 +63,8 @@
     }
 
-    protected override void Manipulate(IRandom random, JSMEncoding individual) {
-      Apply(random, individual);
+    protected override void Manipulate(IRandom random, IScheduleEncoding encoding) {
+      var solution = encoding as JSMEncoding;
+      if (solution == null) throw new InvalidOperationException("Encoding is not of type JSMEncoding");
+      Apply(random, solution);
     }
   }
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMSwapManipulator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMSwapManipulator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMSwapManipulator.cs	(revision 8887)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -26,19 +27,16 @@
 
 namespace HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix {
-
   [Item("JSMSwapManipulator", "Represents a manipulation operation swapping parts of the individual.")]
   [StorableClass]
   public class JSMSwapManipulator : JSMManipulator {
+
     [StorableConstructor]
     protected JSMSwapManipulator(bool deserializing) : base(deserializing) { }
-    protected JSMSwapManipulator(JSMSwapManipulator original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected JSMSwapManipulator(JSMSwapManipulator original, Cloner cloner) : base(original, cloner) { }
+    public JSMSwapManipulator() : base() { }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new JSMSwapManipulator(this, cloner);
     }
-
-    public JSMSwapManipulator() : base() { }
-
 
     public static void Apply(IRandom random, JSMEncoding individual) {
@@ -52,6 +50,8 @@
     }
 
-    protected override void Manipulate(IRandom random, JSMEncoding individual) {
-      Apply(random, individual);
+    protected override void Manipulate(IRandom random, IScheduleEncoding individual) {
+      var solution = individual as JSMEncoding;
+      if (solution == null) throw new InvalidOperationException("Encoding is not of type JSMEncoding");
+      Apply(random, solution);
     }
   }
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRCrossover.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRCrossover.cs	(revision 8887)
@@ -27,5 +27,5 @@
   [Item("PWRCrossover", "An operator which crosses two JSM representations.")]
   [StorableClass]
-  public abstract class PWRCrossover : ScheduleCrossover<PWREncoding>, IPWROperator {
+  public abstract class PWRCrossover : ScheduleCrossover, IPWROperator {
 
     [StorableConstructor]
@@ -41,5 +41,5 @@
 
     public override IOperation Apply() {
-      ItemArray<PWREncoding> parents = ParentsParameter.ActualValue;
+      var parents = ParentsParameter.ActualValue;
 
       ChildParameter.ActualValue =
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRGOXCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRGOXCrossover.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRGOXCrossover.cs	(revision 8887)
@@ -31,17 +31,17 @@
   [StorableClass]
   public class PWRGOXCrossover : PWRCrossover {
+
     [StorableConstructor]
     protected PWRGOXCrossover(bool deserializing) : base(deserializing) { }
-    protected PWRGOXCrossover(PWRGOXCrossover original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected PWRGOXCrossover(PWRGOXCrossover original, Cloner cloner) : base(original, cloner) { }
+    public PWRGOXCrossover() : base() { }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new PWRGOXCrossover(this, cloner);
     }
-    public PWRGOXCrossover() : base() { }
 
     private static int[] GetLookUpForIndividual(List<int> p) {
-      int[] result = new int[p.Count];
-      Dictionary<int, int> lookUpTable = new Dictionary<int, int>();
+      var result = new int[p.Count];
+      var lookUpTable = new Dictionary<int, int>();
 
       for (int i = 0; i < p.Count; i++) {
@@ -54,10 +54,11 @@
       return result;
     }
+
     public static PWREncoding Apply(IRandom random, PWREncoding parent1, PWREncoding parent2) {
-      PWREncoding result = new PWREncoding();
+      var result = new PWREncoding();
 
-      List<int> p1 = ((IntegerVector)(parent1.PermutationWithRepetition.Clone())).ToList<int>();
-      List<int> p2 = ((IntegerVector)(parent2.PermutationWithRepetition.Clone())).ToList<int>();
-      List<int> child = new List<int>();
+      var p1 = ((IntegerVector)(parent1.PermutationWithRepetition.Clone())).ToList();
+      var p2 = ((IntegerVector)(parent2.PermutationWithRepetition.Clone())).ToList();
+      var child = new List<int>();
 
       int[] lookUpArrayP1 = GetLookUpForIndividual(p1);
@@ -90,7 +91,4 @@
     }
 
-
-
-
   }
 }
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs	(revision 8887)
@@ -31,21 +31,21 @@
   [StorableClass]
   public class PWRPPXCrossover : PWRCrossover {
+
     [StorableConstructor]
     protected PWRPPXCrossover(bool deserializing) : base(deserializing) { }
-    protected PWRPPXCrossover(PWRPPXCrossover original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected PWRPPXCrossover(PWRPPXCrossover original, Cloner cloner) : base(original, cloner) { }
+    public PWRPPXCrossover() : base() { }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new PWRPPXCrossover(this, cloner);
     }
-    public PWRPPXCrossover() : base() { }
 
     public static PWREncoding Apply(IRandom random, PWREncoding parent1, PWREncoding parent2) {
-      PWREncoding result = new PWREncoding();
-      List<int> p1 = ((IntegerVector)(parent1.PermutationWithRepetition.Clone())).ToList<int>();
-      List<int> p2 = ((IntegerVector)(parent2.PermutationWithRepetition.Clone())).ToList<int>();
-      List<int> child = new List<int>();
+      var result = new PWREncoding();
+      var p1 = ((IntegerVector)(parent1.PermutationWithRepetition.Clone())).ToList();
+      var p2 = ((IntegerVector)(parent2.PermutationWithRepetition.Clone())).ToList();
+      var child = new List<int>();
 
-      bool[] lookUpTable = new bool[parent1.PermutationWithRepetition.Length];
+      var lookUpTable = new bool[parent1.PermutationWithRepetition.Length];
       for (int i = 0; i < lookUpTable.Length; i++) {
         lookUpTable[i] = random.Next(2) == 1;
@@ -73,5 +73,4 @@
     }
 
-
   }
 }
